#pragma once

#include "gp/containers/vector.hpp"
#include "gp/dynamic/compiler/type/decls.hpp"
#include "gp/utils/allocators/allocator.hpp"

using string = gp::vector<char>;

string gr_mangle_function(gp::vector<gr_type>, gp::allocator&);
gp::vector<gr_type> gr_unmangle_function(string, gp::allocator&);
gr_type gr_get_function_as_type(gr_function func, gp::allocator&);