#pragma once

#include "gp/utils/allocators/buddy.hpp"
#include "gp/utils/allocators/dummy.hpp"

struct static_mapper {
	static gp::array<char, 4096> store;
	static gp::buddy<> impl;

	void* allocate(size_t sz) {
		return impl.allocate(sz);
	}

	bool deallocate(void* ptr) {
		return impl.deallocate(ptr);
	}
};